<template>
  <el-form ref="form" :model="user" :rules="rules" label-width="80px">
    <el-form-item label="旧密码" prop="oldPassword">
      <el-input v-model="user.oldPassword" placeholder="请输入旧密码" type="password" show-password />
    </el-form-item>
    <el-form-item label="新密码" prop="newPassword">
      <el-input v-model.trim="user.newPassword" placeholder="请输入新密码" type="password" @input="handleInput"
        show-password />
    </el-form-item>
    <el-form-item label="确认密码" prop="confirmPassword">
      <el-input v-model.trim="user.confirmPassword" placeholder="请输入确认密码" type="password" show-password />
    </el-form-item>
    <el-form-item>
      <el-button type="primary" size="mini" @click="submit">保存</el-button>
      <el-button type="danger" size="mini" @click="close">关闭</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
  import { updateUserPwd } from "@/api/system/user";

  export default {
    data() {
      const equalToPassword = (rule, value, callback) => {
        if (this.user.newPassword !== value) {
          callback(new Error("两次输入的密码不一致"));
        } else {
          callback();
        }
      };
      const yzNewPassword = (rule, value, callback) => {
        //密码为六位及以上并且字母、数字、特殊字符三项中有两项，强度是中等
        var mediumRegex = /(?!^\d+$)(?!^[A-Za-z]+$)(?!^[^A-Za-z0-9]+$)(?!^.*[\u4E00-\u9FA5].*$)^\S{6,20}$/;
        if (!mediumRegex.test(value)) {
          callback(new Error("请至少使用字母、数字、符号两种类型组合的密码，长度为6~20位。"));
        } else {
          callback();
        }
      };
      return {
        user: {
          oldPassword: undefined,
          newPassword: undefined,
          confirmPassword: undefined
        },
        // 表单校验
        rules: {
          oldPassword: [
            { required: true, message: "旧密码不能为空", trigger: "blur" }
          ],
          newPassword: [
            { required: true, message: "新密码不能为空", trigger: "blur" },
            { required: true, validator: yzNewPassword, trigger: "blur" },
            { min: 6, max: 20, message: "长度在 6 到 20 个字符", trigger: "blur" },
            // { pattern: /^[^<>"'|\\]+$/, message: "不能包含非法字符：< > \" ' \\\ |", trigger: "blur" }
          ],
          confirmPassword: [
            { required: true, message: "确认密码不能为空", trigger: "blur" },
            { required: true, validator: equalToPassword, trigger: "blur" }
          ]
        }
      };
    },
    methods: {
      submit() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            updateUserPwd(this.user.oldPassword, this.user.newPassword).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.$store.dispatch('LogOut').then(() => {
                // location.href = '/index';
                location.href = '/nasc/index.html';
              })
            });
          }
        });
      },
      close() {
        this.$tab.closePage();
      },
      handleInput(event) {
        // 使用正则表达式检查是否包含中文或空格
        if (/[\u4e00-\u9fa5\s]/.test(event)) {
          // 如果包含，则将输入值设置为上一次的值，即去除当前输入的内容
          this.user.newPassword = event.replace(/[\u4e00-\u9fa5\s]/g, '');
        }
      }
    }
  };
</script>
